/*
 * User: Tom
 * Date: 1-aug-2004
 * Time: 23:46:07
 */
package com.tombrus.imageConverter.jobs;

import com.tombrus.imageConverter.JobStep;
import com.tombrus.imageConverter.Job;

import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class Cut extends JobStep {
    private static final Pattern pattern = Pattern.compile("([0-9]+),([0-9]+),([0-9]+),([0-9]+)");
                         int     x;
                         int     y;
                         int     w;
                         int     h;

    public int initFrom(Job job,String[] args,int i) {
        i = super.initFrom(job,args,i);
        i++;
        if (args.length <=i) {
            throw new Error("usage: -Cut x,y,w,h");
        }
        final Matcher matcher = pattern.matcher(args[i]);
        if (!matcher.matches()) {
            throw new Error("usage: -Cut x,y,w,h");
        }
        x = Integer.parseInt(matcher.group(1));
        y = Integer.parseInt(matcher.group(2));
        w = Integer.parseInt(matcher.group(3));
        h = Integer.parseInt(matcher.group(4));
        return i;
    }

    public void run() {
        final BufferedImage image = getJob().getImage();
        if (image !=null) {
            final BufferedImage newImage = new BufferedImage(w,h,image.getType());
            final Graphics2D    g         =   newImage.createGraphics();
            g.drawImage(image,0,0,w,h,x,y,x +w,y +h,null);
            g.dispose();
            getJob().setImage(newImage);
        }
    }
}