/*
 * User: Tom
 * Date: 1-aug-2004
 * Time: 23:49:09
 */
package com.tombrus.imageConverter.jobs;

import com.tombrus.imageConverter.JobStep;
import com.tombrus.imageConverter.Job;

import javax.imageio.ImageIO;
import java.io.File;
import java.io.IOException;
import java.awt.image.BufferedImage;
import java.awt.Graphics2D;

public class Read extends JobStep {
    File file;
    long lastRunTimeStamp;

    public int initFrom(Job job,String[] args,int i) {
        i = super.initFrom(job,args,i);
        i++;
        if (args.length <=i) {
            throw new Error("usage: -Read <file>");
        }
        file = new File(args[i]);
        return i;
    }

    public boolean isRunNeeded() {
        return file.exists() && lastRunTimeStamp <file.lastModified();
    }

    public void run() {
        getJob().setImage(null);
        if (file.exists()) {
            lastRunTimeStamp = file.lastModified();
            try {
                final BufferedImage tmp      = ImageIO.read(file);
                final BufferedImage newImage = new BufferedImage(tmp.getWidth(),tmp.getHeight(),BufferedImage.TYPE_INT_ARGB);
                final Graphics2D    g        = newImage.createGraphics();
                g.drawImage(tmp,0,0,null);
                g.dispose();
                getJob().setImage(newImage);
            } catch (IOException e) {
                new Error("could not read the image from " +file.getAbsolutePath());
            }
        }
    }
}