/*
 * User: Tom
 * Date: 1-aug-2004
 * Time: 23:49:16
 */
package com.tombrus.imageConverter.jobs;

import com.tombrus.imageConverter.JobStep;
import com.tombrus.imageConverter.Job;

import javax.imageio.ImageIO;
import java.awt.image.RenderedImage;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

public class Write extends JobStep {
    File file;

    public int initFrom(Job job,String[] args,int i) {
        i = super.initFrom(job,args,i);
        i++;
        if (args.length <=i) {
            throw new Error("usage: -Write <file>");
        }
        file = new File(args[i]);
        return i;
    }

    public void run() {
        final BufferedImage image = getJob().getImage();
        if (image !=null) {
            try {
                ImageIO.write(image,"png",file);
            } catch (IOException e) {
                new Error("could not read the image from " +file.getAbsolutePath());
            }
        }
    }
}